var g_player = 0;
var g_round = 0;

var g_price = 0;
var g_price_rand = 0;
var g_price_rand_max = 256*256;

function StartGame(player, save)
{
	g_player = player;

	g_price_rand = 256+Math.floor(Math.random()*256*256-512);
	
	
	function ChangePrice()
	{
		var c = 3;
		var a = 4*255+1;
		var m = 256*256;

		g_price_rand = (a*g_price_rand+c)%g_price_rand_max;
		g_price = 0.75+0.5*g_price_rand/g_price_rand_max;
		g_price = Math.floor(g_price*100)/100;
	}
	/*
		main loop
			-Figure out whose turn it is by sorting areas
			-Play each area indiviually
			-Go to next turn;
	*/
	g_round = 0;

	if (save != undefined)
	{
		Load(save);
	}

	var turn_array = new Array(num_areas);
	var smallest = 0;
	var smallest_num = 0;
	
	PlayMusic(1);
	FadeInOverDisplay();
	
	for (gm=0;gm<max_factions;gm++)
		ResetUnitUse(gm);

	
	while (true)
	{
		ChangePrice();
	
		//assign order
		for (gm=0;gm<num_areas;gm++)
		{
			turn_array[gm] = Math.random();
		}
			
		for (gn=0;gn<num_areas;gn++)
		{ 
		  smallest = 2;
		  smallest_num = -1;
			for (gm=0;gm<num_areas;gm++)
			{
				if (turn_array[gm] < smallest)
				{
					smallest = turn_array[gm];
					smallest_num = gm;
				}
			}
			turn_array[smallest_num] = 2;
			if (smallest_num > -1)
				DoTurn(smallest_num);
				
			if (IsWon())
			{
				ShowEnding();
				return;
			}
			else if (IsLost())
			{
				ShowGameOver();
				return;
			}	
				
		}
		g_round++;
		
		for (gm=0;gm<max_factions;gm++)
		{
			if (g_player == gm)
				DiplomancyMenu();
			else
				DoDiplomancy(gm);
				
			if (g_round%4 == 0)
				ResetUnitUse(gm);
		}
		Save("auto");
		SaveQuery();
	}
}

function DoTurn(area)
{
	StoreInfo(area);
	if (areas[area].owner== g_player)
	{
		OverViewMenu(area);
	}
	else if (areas[area].owner > -1)
	{
		DoAi(area);
	}
	AutoImprove(area)
	UpdateChanges(area);
}

function StoreInfo(area)
{
	areas[area].gold_t = areas[area].gold;
	areas[area].food_t = areas[area].food;
	areas[area].mine_t = areas[area].mine;
	areas[area].farm_t = areas[area].farm;
	areas[area].tech_t = areas[area].tech;
	areas[area].fort_t = areas[area].fort;
	areas[area].sold_t = areas[area].sold;
}

function UpdateChanges(area)
{
	areas[area].gold_l = areas[area].gold_t;
	areas[area].food_l = areas[area].food_t;
	areas[area].mine_l = areas[area].mine_t;
	areas[area].farm_l = areas[area].farm_t;
	areas[area].tech_l = areas[area].tech_t;
	areas[area].fort_l = areas[area].fort_t;
	areas[area].sold_l = areas[area].sold_t;
}

var bgc = CreateColor(0,94,138,255);

function OverViewMenu(area)
{
/*
			-Each turn:
				-Draw the map
				-get input
					-general screen
						-army screen 
							-***1***
							-Train troops
								-***5***
								-Menu to select how many troops to train
							-Move troops
								-***5***
								-Move troops to selected region
							-Attack region
								-***5***
								-later
							-Raid
								-***5***
								-later
					!DONE!-town screen
							-***2***
							!DONE!-improve farms
							!DONE!-improve mining
							!DONE!-improve fortification
							!DONE!-improve infrastructure
					-resources screen (send/request)
						-***3***
						!DONE!-send resources
						!DONE!-request resources
						!DONE!-buy food
						!DONE!-sell food
					-diplomancy screen
						-***4***
						1-diplomancy to other nations
							-Ally
							-Request Aid
							-Send Aid
						1-auto distribute
							-none
							-some  (1/8)
							-a lot (1/4)
							-half  (1/2)
							-auto
						-view boundary province
						-View creature(s) status
*/
	
	var lasttime = GetTime();
	var frametime = 1000/30;
	var selected = -1;
	var starty = LoadImage("start1.png");

	var menu_stage = 0;
	//images for status
		//!DONE!-gold
		//!DONE!-food
		//!DONE!-mining
		//!DONE!-farmland
		//!DONE!-protection
		//!DONE!-development(anvil)
		//!DONE!-troops
	var o_gold = LoadImage("o_gold1.png");
	var o_food = LoadImage("o_food1.png");
	var o_mine = LoadImage("o_mine1.png");
	var o_farm = LoadImage("o_farm1.png");
	var o_fort = LoadImage("o_fort1.png");
	var o_tech = LoadImage("o_tech1.png");
	var o_sold = LoadImage("o_sold1.png");

	var o_milt = LoadImage("o_milt1.png");
	var o_town = LoadImage("o_town1.png");
	var o_reso = LoadImage("o_resource1.png");
	var o_dipl = LoadImage("o_diplo1.png");

	var o_next = LoadImage("o_next1.png");
	var o_back = LoadImage("o_back1.png");

	var i_mine = LoadImage("i_mine1.png");
	var i_farm = LoadImage("i_farm1.png");
	var i_fort = LoadImage("i_fort1.png");
	var i_tech = LoadImage("i_tech1.png");

	var m_buy = LoadImage("m_troops1.png");
	var m_mov = LoadImage("m_mtroops1.png");
	var m_atk = LoadImage("m_attack1.png");
	var m_rad = LoadImage("m_raid1.png");
	
	var a_some = LoadImage("a_some1.png");
	var a_half = LoadImage("a_half1.png");
	var a_most = LoadImage("a_most1.png");
	var a_all = LoadImage("a_all1.png");

	var a_cust = LoadImage("a_input1.png");

	var r_send = LoadImage("r_send1.png");
	var r_requ = LoadImage("r_request1.png");
	var r_buy  = LoadImage("r_buy1.png");
	var r_sell = LoadImage("r_sell1.png");

	var g_abit = LoadImage("g_abit1.png");
	var g_some = LoadImage("g_some1.png");
	var g_half = LoadImage("g_half1.png");
	var g_most = LoadImage("g_most1.png");
	var g_all = LoadImage("g_all1.png");
	var g_cust = LoadImage("g_input1.png");

	var f_abit = LoadImage("f_abit1.png");
	var f_some = LoadImage("f_some1.png");
	var f_half = LoadImage("f_half1.png");
	var f_most = LoadImage("f_most1.png");
	var f_all = LoadImage("f_all1.png");
	var f_cust = LoadImage("f_input1.png");

	var d_none = LoadImage("f_none1.png");

	var d_auto = LoadImage("d_auto1.png");
	var d_aid = LoadImage("d_aid1.png");
	var d_view = LoadImage("d_view1.png");
	var d_crea = LoadImage("d_creature1.png");

	var sx = 53;
	var tx = 16;
	var ty = 16;
	var tz = 53;
	
	
	//-four main buttons
		//-troops
		//-town
		//-resources
		//-diplomancy
	var tw;
	var display_message = "";
	var attack_type = 0;
	var amount = 0;
	
	var endcount = 0;
	var end_max = 20;
	
	var r_send_count = -1;
	
	function DisplayAreaInfo(num,viewing)
	{
		window.drawWindow(16,16,320-192-32+10,240-48);
		if (areas[num].owner > -1)
		{
			font.drawTextBox(16,16, 120,120,0,"Faction:\n "+factions[areas[num].owner].name);
			font.drawTextBox(16,16+24, 120,120,0,"Governer:\n "+factions[areas[num].owner].leader);
			if (viewing != true)
				font.drawTextBox(16,16+24*2, 120,120,0,"Unit:\n "+factions[areas[num].owner].unit);
		}
		else 
		{
			font.drawTextBox(16,16, 120,120,0,"Faction:\n None");
			font.drawTextBox(16,16+24, 120,120,0,"Governer:\n None");
			font.drawTextBox(16,16+24*2, 120,120,0,"Unit:\n None");
		}

		o_gold.blit(tx,ty+24*3);
		o_food.blit(tx+sx,ty+24*3);
		o_mine.blit(tx,ty+24*4);
		o_farm.blit(tx+sx,ty+24*4);
		o_tech.blit(tx,ty+24*5);
		o_fort.blit(tx+sx,ty+24*5);
		o_sold.blit(tx,ty+24*6);

		if (menu_stage == 0)
		{
			o_milt.blit(2+tx,2+ty+0+24*7);
			o_town.blit(2+tx+26,2+ty+0+24*7);
			o_reso.blit(2+tx+26*2,2+ty+0+24*7);
			o_dipl.blit(2+tx+26*3,2+ty+0+24*7);
			o_next.blit(2+tx+26*3,ty+24*6);
		}
		else 
			o_back.blit(1+tx+26*2,ty+24*6);
			
		if (menu_stage == 1)
		{
			if (attack_type <=0)
			{
			m_buy.blit(2+tx,2+ty+0+24*7);
			m_mov.blit(2+tx+26,2+ty+0+24*7);
			m_atk.blit(2+tx+26*2,2+ty+0+24*7);
			m_rad.blit(2+tx+26*3,2+ty+0+24*7);
			}
		}
		else if (menu_stage == 2)
		{
			i_farm.blit(2+tx,2+ty+0+24*7);
			i_mine.blit(2+tx+26,2+ty+0+24*7);
			i_tech.blit(2+tx+26*2,2+ty+0+24*7);
			i_fort.blit(2+tx+26*3,2+ty+0+24*7);
		}
		else if (menu_stage == 3)
		{
			if (attack_type <=0)
			{
				r_send.blit(2+tx,2+ty+0+24*7);
				r_requ.blit(2+tx+26,2+ty+0+24*7);
				 r_buy.blit(2+tx+26*2,2+ty+0+24*7);
				r_sell.blit(2+tx+26*3,2+ty+0+24*7);
			}
//			i_tech.blit(2+tx+26*2,2+ty+0+24*7);
//			i_fort.blit(2+tx+26*3,2+ty+0+24*7);
		}
		else if (menu_stage == 4)
		{
				d_auto.blit(2+tx,2+ty+0+24*7);
				 d_aid.blit(2+tx+26,2+ty+0+24*7);
				d_view.blit(2+tx+26*2,2+ty+0+24*7);
				d_crea.blit(2+tx+26*3,2+ty+0+24*7);
		}
		else if (menu_stage == 5)
		{
			if (attack_type == 4 || attack_type == 5|| attack_type == 8)
			{
				if (r_send_count < 0)
				{
					g_some.blit(2+tx,2+ty+0+24*7);
					g_half.blit(2+tx+26,2+ty+0+24*7);
					g_most.blit(2+tx+26*2,2+ty+0+24*7);
					g_all.blit(2+tx+26*3,2+ty+0+24*7);
					g_cust.blit(2+tx+26*3,ty+24*6);
				}
				else
				{
					f_some.blit(2+tx,2+ty+0+24*7);
					f_half.blit(2+tx+26,2+ty+0+24*7);
					f_most.blit(2+tx+26*2,2+ty+0+24*7);
					f_all.blit(2+tx+26*3,2+ty+0+24*7);
					f_cust.blit(2+tx+26*3,ty+24*6);
				}
			}
			else
			{
				a_some.blit(2+tx,2+ty+0+24*7);
				a_half.blit(2+tx+26,2+ty+0+24*7);
				a_most.blit(2+tx+26*2,2+ty+0+24*7);
				a_all.blit(2+tx+26*3,2+ty+0+24*7);
				a_cust.blit(2+tx+26*3,ty+24*6);
			}
		}
		else if (menu_stage == 6)
		{
				d_none.blit(2+tx,2+ty+0+24*7);
				g_abit.blit(2+tx+26,2+ty+0+24*7);
				g_some.blit(2+tx+26*2,2+ty+0+24*7);
				g_half.blit(2+tx+26*3,2+ty+0+24*7);
		}
		else if (menu_stage == 7)
		{
				d_none.blit(2+tx,2+ty+0+24*7);
				f_abit.blit(2+tx+26,2+ty+0+24*7);
				f_some.blit(2+tx+26*2,2+ty+0+24*7);
				f_half.blit(2+tx+26*3,2+ty+0+24*7);
		}

		

		tw = (areas[num].gold+"").length;
		font2.drawText(tz-8*tw+tx,ty+24*3, areas[num].gold);
		tw = (areas[num].food+"").length;
		font2.drawText(tz-8*tw+tx+sx,ty+24*3, areas[num].food);
		tw = (areas[num].mine+"").length;
		font2.drawText(tz-8*tw+tx,ty+24*4, areas[num].mine);
		tw = (areas[num].farm+"").length;
		font2.drawText(tz-8*tw+tx+sx,ty+24*4, areas[num].farm);
		tw = (areas[num].tech+"").length;
		font2.drawText(tz-8*tw+tx,ty+24*5, areas[num].tech);
		tw = (areas[num].fort+"").length;
		font2.drawText(tz-8*tw+tx+sx,ty+24*5, areas[num].fort);
		tw = (areas[num].sold+"").length;
		font2.drawText(tz-8*tw+tx,ty+24*6, areas[num].sold);

		ColouredText(tz+tx,12+ty+24*3, areas[num].gold-areas[num].gold_l);
		ColouredText(tz+tx+sx,12+ty+24*3, areas[num].food-areas[num].food_l);
		ColouredText(tz+tx,12+ty+24*4, areas[num].mine-areas[num].mine_l);
		ColouredText(tz+tx+sx,12+ty+24*4, areas[num].farm-areas[num].farm_l);
		ColouredText(tz+tx,12+ty+24*5, areas[num].tech-areas[num].tech_l);
		ColouredText(tz+tx+sx,12+ty+24*5, areas[num].fort-areas[num].fort_l);
		ColouredText(tz+tx,12+ty+24*6, areas[num].sold-areas[num].sold_l);

		DrawRound();
	}

	function ColouredText(x,y,amount)
	{
		var tw = (amount+"").length;
		if (amount == 0)
			font2.drawText(x-tw*8,y, amount);
		else if (amount> 0)
			font2g.drawText(x-tw*8,y, amount);
		else if (amount< 0)
			font2r.drawText(x-tw*8,y, amount);
	}

	function DisplayExtraInfo(viewing_message)
	{
		var string = "";

		if (IsMouseInBox(tx,ty+24*3,24,24))
			string = "Money";
		if (IsMouseInBox(tx+sx,ty+24*3,24,24))
			string = "Food";
		if (IsMouseInBox(tx,ty+24*4,24,24))
			string = "Mining";
		if (IsMouseInBox(tx+sx,ty+24*4,24,24))
			string = "Farmland";
		if (IsMouseInBox(tx,ty+24*5,24,24))
			string = "Infrastructure";
		if (IsMouseInBox(tx+sx,ty+24*5,24,24))
			string = "Fortification";
		if (IsMouseInBox(tx,ty+24*6,24,24))
			string = "Troops";


		if (IsMouseInBox(tx+24,ty+24*3,sx-24,12))

			string = "Money available.";
		if (IsMouseInBox(tx+24+sx,ty+24*3,sx-24,12))
			string = "Food stored.";
		if (IsMouseInBox(tx+24,ty+24*4,sx-24,12))
			string = "Mining development.";
		if (IsMouseInBox(tx+24+sx,ty+24*4,sx-24,12))
			string = "Farmland development.";
		if (IsMouseInBox(tx+24,ty+24*5,sx-24,12))
			string = "Infrastructure level.";
		if (IsMouseInBox(tx+24+sx,ty+24*5,sx-24,12))
			string = "Fortification level.";
		if (IsMouseInBox(tx+24,ty+24*6,sx-24,12))
			string = "Troops garrisoned.";


		if (IsMouseInBox(tx+24,12+ty+24*3,sx-24,12))
			string = "Money collection";
		if (IsMouseInBox(tx+24+sx,12+ty+24*3,sx-24,12))
			string = "Food harvested";
		if (IsMouseInBox(tx+24,12+ty+24*4,sx-24,12))
			string = "Mines developed";
		if (IsMouseInBox(tx+24+sx,12+ty+24*4,sx-24,12))
			string = "Farmlands improved.";
		if (IsMouseInBox(tx+24,12+ty+24*5,sx-24,12))
			string = "Infrastructure built";
		if (IsMouseInBox(tx+24+sx,12+ty+24*5,sx-24,12))
			string = "Fortifications made";
		if (IsMouseInBox(tx+24,12+ty+24*6,sx-24,12))
			string = "Troops trained";

		if (menu_stage == 0)
		{
			if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
				string = "Military menu.";
			if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
				string = "Development menu.";
			if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
				string = "Resources menu.";
			if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
				string = "Misc. menu.";
			if (IsMouseInBox(2+tx+26*3,ty+24*6,sx-24,24))
				string = "End turn.";
		}
		else
		{
			if (IsMouseInBox(1+tx+26*2,ty+24*6,sx-24,24))
				string = "Previous menu.";
		}
		if (menu_stage == 1)
		{
			if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
				string = "Train troops.";
			if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
				string = "Move troops.";
			if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
				string = "Attack region.";
			if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
				string = "Raid region.";
		}
		else if (menu_stage == 2)
		{
			if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
				string = "Improve farmland (5g1t).";
			if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
				string = "Improve mines (5g1t).";
			if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
				string = "Improve infrastructure (5g1t).";
			if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
				string = "Improve fortifications (5g1t).";
		}
		else if (menu_stage == 3)
		{
			if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
				string = "Send Resources.";
			if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
				string = "Request Resources.";
			if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
				string = "Buy Food.";
			if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
				string = "Sell Food.";
		}
		else if (menu_stage == 4)
		{
			if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
				string = "Auto Distribute.";
			if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
				string = "Send Aid.";
			if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
				string = "View Border Province.";
			if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
				string = "View Creature Status.";
		}
		else if (menu_stage == 5)
		{
			if (attack_type == 5 && r_send_count < 0)
				string = "Receive how much gold?";
			else if (attack_type == 4 && r_send_count < 0)
				string = "Send how much gold?";
			else if (attack_type == 5)
				string = "Receive how much food?";
			else if (attack_type == 4)
				string = "Send how much food?";
			else if (attack_type == 6)
				string = "Buy how much? (1f-"+g_price+"g)";
			else if (attack_type == 7)
				string = "Sell how much? (1f-"+g_price+"g)";
			else if (attack_type == 8 && r_send_count < 0)
				string = "Send how much gold?";
			else if (attack_type == 8)
				string = "Send how much food?";
			else
				string = "Send how many troops?";

			if (attack_type == 5)
			{
				if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
					string = "Receive a quarter.";
				if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
					string = "Receive half.";
				if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
					string = "Receive three quarters.";
				if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
					string = "Receive all.";
				if (IsMouseInBox(2+tx+26*3,ty+24*6,sx-24,24))
					string = "Input amount to receive.";
			}
			else if (attack_type == 6)
			{
				if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
					string = "Buy a quarter.";
				if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
					string = "Buy half.";
				if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
					string = "Buy three quarters.";
				if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
					string = "Buy all.";
				if (IsMouseInBox(2+tx+26*3,ty+24*6,sx-24,24))
					string = "Input amount to buy.";
			}
			else if (attack_type == 7)
			{
				if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
					string = "Sell a quarter.";
				if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
					string = "Sell half.";
				if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
					string = "Sell three quarters.";
				if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
					string = "Sell all.";
				if (IsMouseInBox(2+tx+26*3,ty+24*6,sx-24,24))
					string = "Input amount to sell.";
			}
			else if (attack_type == 8)
			{
				//send
				if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
					string = "Send a quarter.";
				if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
					string = "Send half.";
				if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
					string = "Send three quarters.";
				if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
					string = "Send all.";
				if (IsMouseInBox(2+tx+26*3,ty+24*6,sx-24,24))
					string = "Input amount to send.";
			}
			else if (attack_type == 0)
			{
				if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
					string = "Train a quarter.";
				if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
					string = "Train half.";
				if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
					string = "Train three quarters.";
				if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
					string = "Train all.";
				if (IsMouseInBox(2+tx+26*3,ty+24*6,sx-24,24))
					string = "Input amount to train.";
			}			
			else
			{
				if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
					string = "Send a quarter.";
				if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
					string = "Send half.";
				if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
					string = "Send three quarters.";
				if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
					string = "Send all.";
				if (IsMouseInBox(2+tx+26*3,ty+24*6,sx-24,24))
					string = "Input amount to send.";
			}
		}
		else if (menu_stage == 6)
		{
			if (areas[area].auto_gold == 0)
				string = "Not distributing gold.";
			if (areas[area].auto_gold == 1)
				string = "Distributing 1/8 gold.";
			if (areas[area].auto_gold == 1)
				string = "Distributing 1/4 gold.";
			if (areas[area].auto_gold == 1)
				string = "Distributing 1/2 gold.";

			if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
				string = "Don't distribute gold.";
			if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
				string = "Distribute 1/8 gold.";
			if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
				string = "Distribute 1/4 gold.";
			if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
				string = "Distribute half gold.";
		}
		else if (menu_stage == 7)
		{
			if (areas[area].auto_food == 0)
				string = "Not distributing food.";
			if (areas[area].auto_food == 1)
				string = "Distributing 1/8 food.";
			if (areas[area].auto_food == 1)
				string = "Distributing 1/4 food.";
			if (areas[area].auto_food == 1)
				string = "Distributing 1/2 food.";

			if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
				string = "Don't distribute food.";
			if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
				string = "Distribute 1/8 food.";
			if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
				string = "Distribute 1/4 food.";
			if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
				string = "Distribute half food.";
		}
		
		if (menu_stage != 5)
		{
			if (attack_type == 1)
				string = "Move troops to where?";
			if (attack_type == 2)
				string = "Attack what region?";
			if (attack_type == 3)
				string = "Raid what region?";
			if (attack_type == 4)
				string = "Send to what region?";
			if (attack_type == 5)
				string = "Receive from what region?";
			if (attack_type == 8)
				string = "Aid what region?";
			if (attack_type == 9)
				string = "View what region?";
		}
		if (viewing_message!=undefined)
		{
			string = viewing_message;
		}

		if (string != "")
		{
			window.drawWindow(16,240-16,320-192+64,5);
			font.drawText(17,240-16-3, string);
		}
	}

	var mframes = 0;
	var boundy = -1;
	var tempyy = "";
	while(endcount<end_max)
	{
		if (attack_type > 0 && attack_type != 6 && attack_type != 7)
		{
			if (boundy <0)
			  boundy = 0;
			boundy++;
			tempyy = "";
			if (attack_type == 3 && factions[areas[area].owner].searaid == true)//raid
				tempyy = "raid";
		}
		else
		{
			boundy = -1;
			tempyy = "";
		}

		Rectangle(0,0,320,240,bgc);
		if (endcount <1)
		{
			if (boundy==-1)
			{
				if (mframes%16<8)
					DrawMap(area, boundy);
				else
					DrawMap(undefined, boundy);
			}
			else
			{
				if (mframes%24<16)
				{
					if (mframes%24<16)
						DrawMap(area, boundy);//, tempyy,area);
					else
						DrawMap(area, boundy, tempyy,area);
				}
				else
				{
					if (mframes%24<16)
						DrawMap(undefined, boundy);
					else
						DrawMap(area, boundy, tempyy,area);
				}
			}
		}
		else
		{
			DrawMap(area, boundy, tempyy,area);
		}

		DisplayAreaInfo(area);
		if (display_message == "")
			DisplayExtraInfo();
		else
		{
			window.drawWindow(64,120-3,320-128,6);
			font.drawText(64, 120-6, display_message);
		}
		

		if (endcount > 0)
		{
			endcount++;
		}
		else 
		{
			if (IsKeyPressed(KEY_SPACE) && mframes>10)
			{
				DoAi(area);
				endcount = 1;
			}
			
			while(AreKeysLeft())
			{
				switch(GetKey())
				{
					case KEY_ESCAPE:
					{
						if (attack_type>0)
						{
							attack_type = 0;
						}
						break;
					}
				}
			}
	
			if (IsMouseButtonPressed(MOUSE_LEFT) && ml_pressed == false)
			{
				ml_pressed = true;
				if (display_message != "")
				{
					display_message = "";
				}
				else if (attack_type > 0 && menu_stage != 5)
				{
					if (factions[areas[area].owner].searaid == true && attack_type == 3)
						attack_region = GetMapClick(area, "searaid");
					else
						attack_region = GetMapClick(area);
					if (attack_region > -1)
					{
						//...
						//attack/move/raid this region
						PlaySound(0);

						if (attack_type == 9)
						{
							if (area != attack_region)
							{
								ViewProvince(attack_region);
								menu_stage = 0;
								r_send_count = -1;
								attack_type = 0;
							}
							else 
								display_message = "That is the current region.";
						}
						else
						{
							menu_stage = 5;//amount menu
							r_send_count = -1;
						}
					}
					else if (attack_region == -1)
					{
						r_send_count = -1;
						attack_type = 0;
						attack_region = 0;
					}
				
				}
				else			
				{
					if (menu_stage == 0)
					{
						if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
						{
							PlaySound(0);
							menu_stage = 1;
						}
						if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
						{
							PlaySound(0);
							menu_stage = 2;
						}
						if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
						{
							PlaySound(0);
							menu_stage = 3;
						}
						if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
						{
							PlaySound(0);
							menu_stage = 4;
						}
		
						if (IsMouseInBox(2+tx+26*3,ty+24*6,sx-24,24))
						{
							PlaySound(0);
							endcount = 1;
						}
					}
					else 
					{
						if (IsMouseInBox(1+tx+26*2,2+ty+0+24*6,24,24))
						{
							PlaySound(0);
							attack_type = 0;
							menu_stage = 0;
						}
					
						if (menu_stage == 1)
						{
							if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
							{
								//buy troops
								PlaySound(0);
								attack_type = 0;
								menu_stage = 5;
							}
							if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
							{
								//move troops
								PlaySound(0);
								attack_type = 1;
							}
							if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
							{
								//attack
								PlaySound(0);
								attack_type = 2;
							}
							if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
							{
								//raid
								PlaySound(0);
								attack_type = 3;
							}
						}
						else if (menu_stage == 2)
						{
							if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
							{
								PlaySound(0);
								if (ImproveFarms(area) == 1)
									endcount = 1;
								else
									display_message = "Not enough money.";
							}
							if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
							{
								PlaySound(0);
								if (ImproveMines(area) == 1)
									endcount = 1;
								else
									display_message = "Not enough money.";
							}
							if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
							{
								PlaySound(0);
								if (ImproveTech(area) == 1)
									endcount = 1;
								else
									display_message = "Not enough money.";
							}
							if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
							{
								PlaySound(0);
								if (ImproveFort(area) == 1)
									endcount = 1;
								else
									display_message = "Not enough money.";
							}
						}
						else if (menu_stage == 3)
						{
							if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
							{
								//send resources
								PlaySound(0);
								attack_type = 4;
								r_send_count = -1;
							}
							if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
							{
								//request resources
								PlaySound(0);
								attack_type = 5;
								r_send_count = -1;
							}

							if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
							{
								//buy resources
								PlaySound(0);
								attack_type = 6;
								menu_stage = 5;
							}
							if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
							{
								//sell resources
								PlaySound(0);
								attack_type = 7;
								menu_stage = 5;
							}
						}
						else if (menu_stage == 4)
						{
							if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
							{
								//auto manage resources
								PlaySound(0);
								menu_stage = 6;
							}
							if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
							{
								//send resources
								PlaySound(0);
								attack_type = 8;
								r_send_count = -1;
							}

							if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
							{
								//view province
								PlaySound(0);
								attack_type = 9;
							}
							if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
							{
								//view creature status
								PlaySound(0);
								display_message = "Uses left this year: "+factions[g_player].unit_use+".";
							}
						}
						else if (menu_stage == 5)
						{
							amount = -1;
							if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
							{
								PlaySound(0);
								if (attack_type == 0)
									amount = Math.floor(areas[area].gold/4);
								else if (attack_type == 4 && r_send_count < 0)
									amount = Math.floor(areas[area].gold/4);
								else if (attack_type == 5 && r_send_count < 0)
									amount = Math.floor(areas[attack_region].gold/4);
								else if (attack_type == 4)
									amount = Math.floor(areas[area].food/4);
								else if (attack_type == 5)
									amount = Math.floor(areas[attack_region].food/4);
								else if (attack_type == 6)
									amount = Math.floor(areas[area].gold/4);
								else if (attack_type == 7)
									amount = Math.floor(areas[area].food/4);
								else if (attack_type == 8 && r_send_count < 0)
									amount = Math.floor(areas[area].gold/4);
								else if (attack_type == 8)
									amount = Math.floor(areas[area].food/4);
								else
									amount = Math.floor(areas[area].sold/4);
							}
							if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
							{
								PlaySound(0);
								if (attack_type == 0)
									amount = Math.floor(areas[area].gold/2);
								else if (attack_type == 4 && r_send_count < 0)
									amount = Math.floor(areas[area].gold/2);
								else if (attack_type == 5 && r_send_count < 0)
									amount = Math.floor(areas[attack_region].gold/2);
								else if (attack_type == 4)
									amount = Math.floor(areas[area].food/2);
								else if (attack_type == 5)
									amount = Math.floor(areas[attack_region].food/2);
								else if (attack_type == 6)
									amount = Math.floor(areas[area].gold/2);
								else if (attack_type == 7)
									amount = Math.floor(areas[area].food/2);
								else if (attack_type == 8 && r_send_count < 0)
									amount = Math.floor(areas[area].gold/2);
								else if (attack_type == 8)
									amount = Math.floor(areas[area].food/2);
								else
									amount = Math.floor(areas[area].sold/2);
							}
							if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
							{
								PlaySound(0);
								if (attack_type == 0)
									amount = Math.floor(3*areas[area].gold/4);
								else if (attack_type == 4 && r_send_count < 0)
									amount = Math.floor(3*areas[area].gold/4);
								else if (attack_type == 5 && r_send_count < 0)
									amount = Math.floor(3*areas[attack_region].gold/4);
								else if (attack_type == 4)
									amount = Math.floor(3*areas[area].food/4);
								else if (attack_type == 5)
									amount = Math.floor(3*areas[attack_region].food/4);
								else if (attack_type == 6)
									amount = Math.floor(3*areas[area].gold/4);
								else if (attack_type == 7)
									amount = Math.floor(3*areas[area].food/4);
								else if (attack_type == 8 && r_send_count < 0)
									amount = Math.floor(3*areas[area].gold/4);
								else if (attack_type == 8)
									amount = Math.floor(3*areas[area].food/4);
								else
									amount = Math.floor(3*areas[area].sold/4);
							}
							if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
							{
								PlaySound(0);
								if (attack_type == 0)
									amount = areas[area].gold;
								else if (attack_type == 4 && r_send_count < 0)
									amount = Math.floor(areas[area].gold);
								else if (attack_type == 5 && r_send_count < 0)
									amount = Math.floor(areas[attack_region].gold);
								else if (attack_type == 4)
									amount = Math.floor(areas[area].food);
								else if (attack_type == 5)
									amount = Math.floor(areas[attack_region].food);
								else if (attack_type == 6)
									amount = Math.floor(areas[area].gold);
								else if (attack_type == 7)
									amount = Math.floor(areas[area].food);
								else if (attack_type == 8 && r_send_count < 0)
									amount = Math.floor(areas[area].gold);
								else if (attack_type == 8)
									amount = Math.floor(areas[area].food);
								else
									amount = areas[area].sold;
							}
							
							if (IsMouseInBox(2+tx+26*3,ty+0+24*6,24,24))
							{
								PlaySound(0);
								if (attack_type == 0)
									amount = InputAmount("gold", area);
								else if (attack_type == 4 && r_send_count < 0)
									amount = InputAmount("gold", area);
								else if (attack_type == 5 && r_send_count < 0)
									amount = InputAmount("gold", attack_region);
								else if (attack_type == 4)
									amount = InputAmount("food", area);
								else if (attack_type == 5)
									amount = InputAmount("food", attack_region);
								else if (attack_type == 6)
									amount = InputAmount("gold", area);
								else if (attack_type == 7)
									amount = InputAmount("food", area);
								else if (attack_type == 8 && r_send_count < 0)
									amount = InputAmount("gold", area);
								else if (attack_type == 8)
									amount = InputAmount("food", area);
								else
									amount = InputAmount("sold", area);
							
								if (amount == -1)
								{
									
								}
							}
						
							if (amount > -1)
							{
								if (attack_type == 0)
								{
									PlaySound(0);
									BuyTroops(amount, area);
									endcount = 1;
								}
								else if (attack_type == 1)
								{
									PlaySound(0);
									if (areas[area].owner == areas[attack_region].owner)
									{
										MoveTroops(amount, area, attack_region);
										menu_stage = 0;
										attack_type = 0;
									}
									else
										display_message = "That region is not yours.";
								}
								else if (attack_type == 2)
								{
									PlaySound(0);
									if (areas[area].owner != areas[attack_region].owner)
									{
										AttackTroops(amount, area, attack_region);
										endcount = 1;
									}
									else
										display_message = "That region is yours.";
								}
								else if (attack_type == 3)
								{
									PlaySound(0);
									if (areas[area].owner != areas[attack_region].owner && areas[attack_region].owner > -1)
									{
										RaidTroops(amount, area, attack_region);
										endcount = 1;
									}
									else if (areas[attack_region].owner == -1)
										display_message = "That region is not occupied.";
									else if (areas[area].owner == areas[attack_region].owner)
										display_message = "That region is yours.";
								}
								else if (attack_type == 4 || attack_type == 5)
								{
									PlaySound(0);
									if (areas[area].owner == areas[attack_region].owner)
									{

										if (attack_type == 4 || attack_type == 5)
										{
											PlaySound(0);
											if (r_send_count == -1)
											{
												r_send_count = amount;
											}
											else
											{
												if (attack_type == 4)
												{
													SendGold(r_send_count, area, attack_region);
													SendFood(amount, area, attack_region);
													menu_stage = 0;
													r_send_count = -1;
													attack_type = 0;
												}
												else if (attack_type == 5)
												{
													SendGold(r_send_count, attack_region, area);
													SendFood(amount, attack_region, area);
													menu_stage = 0;
													r_send_count = -1;
													attack_type = 0;
												}
											}
										}
									}
									else
										display_message = "That region is not yours.";
								}
								else if (attack_type == 6 || attack_type == 7)
								{
									PlaySound(0);
									if (attack_type == 6)
									{
										BuyFood(area, amount);
										menu_stage = 0;
										r_send_count = -1;
										attack_type = 0;
									}
									else if (attack_type == 7)
									{
										SellFood(area, amount);
										menu_stage = 0;
										r_send_count = -1;
										attack_type = 0;
									}
								}
								else if (attack_type == 8)
								{
									PlaySound(0);
									if (areas[area].owner != areas[attack_region].owner && areas[attack_region].owner>-1)
									{
										if (r_send_count == -1)
										{
											r_send_count = amount;
										}
										else
										{
											//offer aid
											OfferAid(area,attack_region, r_send_count, amount);
											menu_stage = 0;
											r_send_count = -1;
											attack_type = 0;
										}
									}
									else if (areas[attack_region].owner==-1)
										display_message = "That region is nobody's.";
									else 
										display_message = "That region is yours.";
								}
							}
						}
						else if (menu_stage == 6)
						{
							if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
							{
								PlaySound(0);
								//none
								areas[area].auto_gold=0;
								menu_stage=7;
							}
							if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
							{
								PlaySound(0);
								//a bit
								areas[area].auto_gold=1;
								menu_stage=7;
							}

							if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
							{
								PlaySound(0);
								//some 
								areas[area].auto_gold=2;
								menu_stage=7;
							}
							if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
							{
								PlaySound(0);
								//half
								areas[area].auto_gold=3;
								menu_stage=7;
							}
						}
						else if (menu_stage == 7)
						{
							if (IsMouseInBox(2+tx,2+ty+0+24*7,24,24))
							{
								PlaySound(0);
								//none
								areas[area].auto_food=0;
								menu_stage=0;
							}
							if (IsMouseInBox(2+tx+26,2+ty+0+24*7,24,24))
							{
								PlaySound(0);
								//a bit
								areas[area].auto_food=1;
								menu_stage=0;
							}

							if (IsMouseInBox(2+tx+26*2,2+ty+0+24*7,24,24))
							{
								PlaySound(0);
								//some 
								areas[area].auto_food=2;
								menu_stage=0;
							}
							if (IsMouseInBox(2+tx+26*3,2+ty+0+24*7,24,24))
							{
								PlaySound(0);
								//half
								areas[area].auto_food=3;
								menu_stage=7;
							}
						}
						
						
					}
				}
			}
			else if (!IsMouseButtonPressed(MOUSE_LEFT))
			{
				ml_pressed = false;
			}
		}
	
		g_mouse.blit(GetMouseX(),GetMouseY());
		while(GetTime()-lasttime < frametime);
		lasttime = GetTime();
		if (endcount != 1)
			FlipScreen();
		mframes++;
	}


	function ViewProvince(area)
	{
		var nframes = 0;
	
		while(AreKeysLeft())
			GetKey();

		ml_pressed = true;
		while(true)
		{
			Rectangle(0,0,320,240,bgc);
			if (nframes%16<8)
				DrawMap(area);
			else
				DrawMap();
			
			DisplayAreaInfo(area);
			if (display_message == "")
				DisplayExtraInfo("Viewing area "+areas[area].name+".");
			else
			{
				window.drawWindow(64,120-3,320-128,6);
				font.drawText(64, 120-6, display_message);
			}
		
			g_mouse.blit(GetMouseX(),GetMouseY());
			while(GetTime()-lasttime < frametime);
			lasttime = GetTime();
			nframes++;

			
			if (!IsMouseButtonPressed(MOUSE_LEFT))
			{
				ml_pressed = false;
			}
			else if (ml_pressed == false)
			{
				PlaySound(0);
				ml_pressed = true;
				return;
			}
			
			if (AreKeysLeft())
			{
				while(AreKeysLeft())
					GetKey();
				return;
			}
		FlipScreen();
		}
	}
	


	
}

function DiplomancyMenu()
{
	var nframes = 0;
	var black = CreateColor(0,0,0,255);
	var select_colour = CreateColor(255,255,255,128);
	
	while(AreKeysLeft())
		GetKey();

	ml_pressed = true;

	//count the number of regions for each faction
	for (s=0;s<max_factions;s++)
	{
		factions[s].num_areas = 0;
		for (t=0;t<max_factions;t++)
		{
			if (factions[s].hate[t] <-10000)
				factions[s].hate[t] = -10000;
			if (factions[s].hate[t] >10000)
				factions[s].hate[t] = 10000;
			factions[s].selected = -1;
		}
	}
		
	for (s=0;s<num_areas;s++)
	{
		if (areas[s].owner > -1)
			factions[areas[s].owner].num_areas++;
	}
	
	var scount = 0;
	for (s=0;s<max_factions;s++)
	{
		if (factions[s].num_areas > 0)
			factions[s].selected = scount;
		scount++;
	}

	var dd_xoff = 8-1;
	var dd_yoff = 16+12+6;
	
	var next = LoadImage("diplo_continue.png");
	var ally = LoadImage("diplo_ally1.png");
	var bally = LoadImage("diplo_bally1.png");
	var cease = LoadImage("diplo_cease1.png");
	
	var selected_f = 0;
	var tempy=0;
	var dcounty = 0;
	
	function DisplayDiplomacy()
	{
//		window.drawWindow(16,16,320-192-32+10,240-48);
	
		window2.drawWindow(8,4+2,64,10);
		font.drawText(8+1,4-1+2, "Diplomacy");

		window2.drawWindow(80,4+2,32,22);
		next.blit(80,4+2);
	
		var dcount=0;
		//offer alliances
		for (s=0;s<max_factions;s++)
		{
			if (factions[s].name != "" && s != g_player && factions[s].num_areas> 0)
			{
				Rectangle(dd_xoff,dd_yoff+dcount*40, 130+2,36+2, black);
				Rectangle(dd_xoff+1,dd_yoff+dcount*40+1, 130,36, factions[s].colour);
				if (dcount == selected)
				{
					Rectangle(dd_xoff+1,dd_yoff+dcount*40+1, 130,36, select_colour);
				}
				if (factions[g_player].allied[s]==1)
					font.drawText(dd_xoff+2, dcount*40+1+dd_yoff, factions[s].name+" (Ally)");
				else if (factions[g_player].allied[s]==-1)
					font.drawText(dd_xoff+2, dcount*40+1+dd_yoff, factions[s].name+" (War)");
				else
					font.drawText(dd_xoff+2, dcount*40+1+dd_yoff, factions[s].name);
				font.drawText(dd_xoff+2, dcount*40+1+12+dd_yoff, "Regions: "+factions[s].num_areas);
				font.drawText(dd_xoff+2, dcount*40+1+24+dd_yoff, "Relations: "+ReturnHate(factions[s].hate[g_player]));
				dcount++;
			}
		}
		
		if (selected >-1)
		{
			stringy = "";
			if (IsMouseInBox(320-100-8+2,190+2, ally.width, ally.height))
			{
				if (factions[g_player].allied[selected_f] == -1)
					stringy = "Offer ceasefire";
				else if (factions[g_player].allied[selected_f] == 0)
					stringy = "Make alliance";
			}
			if (IsMouseInBox(320-8-2-bally.width,190+2, bally.width, bally.height))
				stringy = "Break alliance";
				
			if (diplo_move==1)
				stringy = "";

		
		
			//draw options for this 
			window2.drawWindow(320-100-8-4,190,104,40);

			if (diplo_move!=1)
			{
				if (factions[g_player].allied[selected_f] == -1)
					cease.blit(320-100-8+2-4,190+2);
				else
					ally.blit(320-100-8+2-4,190+2);
				bally.blit(320-8-2-bally.width-4,190+2);
			}
			font.drawText(320-100-8+2-4, 190+32-5, stringy);
		
			//show other alliances
			window2.drawWindow(320-100-8-4,140,104,40);
			dcounty = 0;
			font.drawText(320-100-8-4,140, "Allied with:");
			for (f=0;f<max_factions;f++)
			{
				if (f!=selected_f)
				{
					if (factions[f].num_areas>0 && factions[selected_f].num_areas>0)
					{
						if (factions[f].allied[selected_f] == 1)
						{
							dcounty++;
							font.drawText(320-100-8-4,140+dcounty*12, factions[f].name);
						}
					}
				}
			}
		}
	}

	var stringy = ""
	display_message = "";
	var lasttime = GetTime();
	var frametime = 1000/30;
	var selected = -1;
	var diplo_move = 0;

	while(true)
	{
		Rectangle(0,0,320,240,bgc);
		DrawMap();
			
		DisplayDiplomacy();

		if (display_message == "");
		else
		{
			window.drawWindow(32,120-3,320-128+64,6);
			font.drawText(32, 120-6, display_message);
		}
		
		g_mouse.blit(GetMouseX(),GetMouseY());
		while(GetTime()-lasttime < frametime);
		lasttime = GetTime();
		nframes++;

		if (!IsMouseButtonPressed(MOUSE_LEFT))
		{
			ml_pressed = false;
		}
		else if (ml_pressed == false)
		{
			ml_pressed = true;
			
			if (display_message != "")
			{
				display_message = "";
			}
			else
			{
				for (s=0;s<scount;s++)
				{
					if (IsMouseInBox(dd_xoff,dd_yoff+s*40, 130+2,36+2))
					{
						break;
					}
				}
				if (s<scount)
				{
					PlaySound(0);
					selected = s;

					tempy=0;
					for (s=0;s<max_factions;s++)
					{
						if (factions[s].name != "" && s != g_player && factions[s].num_areas> 0)
						{
							if (tempy == selected)
							{
								selected_f = s;
								break;
							}
							tempy++;
						}
					}
				}
	
				if (IsMouseInBox(80,4, 32,24))
				{
					PlaySound(0);
					return;
				}
	
	
				if (IsMouseInBox(320-100-8+2,190+2, ally.width, ally.height) && diplo_move!=1)
				{
					PlaySound(0);
					if (factions[g_player].allied[selected_f] == -1)
					{
						if (OfferCeasefire(g_player, selected_f))
							display_message = "Ceasefire accepted.";
						else
							display_message = "Ceasefire offer rejected.";
						diplo_move=1;
					}
					else if (factions[g_player].allied[selected_f] == 0)
					{
						if (OfferAlliance(g_player, selected_f))
							display_message = "Alliance accepted.";
						else
							display_message = "Alliance offer rejected.";
						diplo_move=1;
					}
					else 
						display_message = "Already allied.";
				}

				if (IsMouseInBox(320-8-2-bally.width,190+2, bally.width, bally.height))
				{
					PlaySound(0);
					if (factions[g_player].allied[selected_f] != 1)
						display_message="You're not allied with this faction.";
					else
					{
						factions[g_player].allied[selected_f] = 0;
						factions[selected_f].allied[g_player] = 0;
						factions[selected_f].hate[g_player] +=250;
						display_message="Alliance broken.";
					}
				}
			}
		}
			
		if (display_message != "")
		{
			if (AreKeysLeft())
			{
				GetKey();
				display_message = "";
			}
		}
		else
		{
			while (AreKeysLeft())
			{
				switch(GetKey())
				{
					case KEY_ESCAPE:
					{
						return;
					}
				}
			}
		}

		FlipScreen();
	}
	


}	

function DrawRound()
{
	window2.drawWindow(320-192-48-8,16,96+8,10);

	var year = Math.floor(g_round/4)+1;
	var season = "";

	if (g_round %4==0)
		season = "Winter";
	else if (g_round %4==1)
		season = "Spring";
	else if (g_round %4==2)
		season = "Summer";
	else 
		season = "Fall";
	
	var string =season+": year "+year;
	
	if (96+8<font.getStringWidth(string))
		window2.drawWindow(320-192-48-8,16,font.getStringWidth(string),10);
	
	font.drawText(320-192+1-48-8,16-1, season+": year "+year);
}

function SaveQuery()
{
	var times = new Array();
	var tfactions = new Array();
	var num_areas = new Array();
	var slot = OpenFile("saveauto.sav");

	function ResetData()
	{
		slot = OpenFile("saveauto.sav");
		g_loaded_player = slot.read("g_player", 0);
		times[-1] = slot.read("time", "d");
		tfactions[-1] = slot.read("g_player", -1);
	
		if (tfactions[-1] > -1)
			num_areas[-1] = slot.read("fact"+g_loaded_player+"num_areas", -1);
		else
			num_areas[-1] = -1;
			
		var g_loaded_player=0;
	
		for (l=0;l<max_slots;l++)
		{
		
			slot = OpenFile("save"+l+".sav");
			g_loaded_player = slot.read("g_player", 0);
			times[l] = slot.read("time", "d");
			tfactions[l] = slot.read("g_player", -1);
			if (tfactions[l] > -1)
				num_areas[l] = slot.read("fact"+g_loaded_player+"num_areas", -1);
			else
				num_areas[l] = -1;
		}
	}

	ResetData();

	var frames = 0;
	var black = CreateColor(0,0,0,255);
	var select_colour = CreateColor(255,255,255,128);
	
	while(AreKeysLeft())
		GetKey();

	ml_pressed = true;

	var selected_f = 0;
	
	var save = LoadImage("s_save1.png");
	var load = LoadImage("s_load1.png");
	var next = LoadImage("diplo_continue.png");

	var stringy = ""
	var stringy_num = 0;

	var lasttime = GetTime();
	var frametime = 1000/30;
	var sselection = -1;
	
	var menu_type = -1;//unselected
	
	var px=80;
	var py=30;
	
	function DisplaySaveLoadMenu()
	{
		window2.drawWindow(8,4+2,64,10);
		if (menu_type == -1)
			font.drawText(8+1,4-1+2, "Data Menu");
		else if (menu_type == 0)
			font.drawText(8+1,4-1+2, "Save Menu");
		else if (menu_type == 1)
			font.drawText(8+1,4-1+2, "Load Menu");

		//draw options for this 
		window2.drawWindow(320-100-8-4,190,104,40);

		save.blit(320-100-8+2-4,190+2);
		load.blit(320-8-2-load.width-4,190+2);

		window2.drawWindow(80,4+2,32,22);
		next.blit(80,4+2);
		
		if (menu_type != -1)
		{

			py = 30;

			if (menu_type == 1)
			{
				font.drawText(4,py, "Auto Save");
				if (frames%8 <4 || sselection != 0)
				{
					if (num_areas[-1] > -1)
						font.drawText(px,py, times[-1]+", "+factions[tfactions[-1]].name+", Areas: "+num_areas[-1]);
					else
						font.drawText(px,py, "empty");
				}
			}

			if (menu_type == 0)
				py = 30;
			else if (menu_type == 1)
				py = 30+12;

			for (st=0;st<max_slots;st++)
			{
				if (frames%8 <4 || sselection != st+1)
				{
					if (num_areas[st] > -1)
						font.drawText(px,py+12*st, times[st]+" "+factions[tfactions[st]].name+", Areas: "+num_areas[st]);
					else
						font.drawText(px,py+12*st, "empty");
				}
			}
	
			if (menu_type == 0)
			{
				font.drawText(120,50+12*st, "Save Game");
			}
			else if (menu_type == 1)
			{
				font.drawText(120,50+12*st, "Load Game");
			}
		}
	}

	while(true)
	{
		Rectangle(0,0,320,240,bgc);
		DrawMap();
			

		DisplaySaveLoadMenu();
		if (stringy != "")
		{
			window.drawWindow(32,120-3,320-128+64,6);
			font.drawText(32, 120-6, stringy);
		}
		
		g_mouse.blit(GetMouseX(),GetMouseY());
		while(GetTime()-lasttime < frametime);
		lasttime = GetTime();
		frames++;

		if (stringy != "")
		{
			stringy_num--;
			if (stringy_num <0)
			{
				if (menu_type == 1)
					return;
				stringy = "";
			}
		}
		else
		{
			if (!IsMouseButtonPressed(MOUSE_LEFT))
			{
				ml_pressed = false;
			}
	
			if (ml_pressed == false && IsMouseButtonPressed(MOUSE_LEFT)==true)
			{
				ml_pressed = true;
				if (IsMouseInBox(320-100-8+2-4,190+2, save.width, save.height))
				{
					PlaySound(0);
					sselection = -1;
					menu_type = 0;
				}
				if (IsMouseInBox(320-8+2-load.width-4,190+2, load.width, load.height))
				{
					PlaySound(0);
					sselection = -1;
					menu_type = 1;
				}
				
	
	
	
				if (menu_type == 0)
					py = 30;
				else if (menu_type == 1)
					py = 30+12;
	
				if (menu_type == 0)
				{
					for (st=0;st<max_slots;st++)
					{
						if (IsMouseInBox(px,30+12*st, 320-8, 12))
						{
							PlaySound(0);
							sselection = st+1;
						}
					}
				}
				else if (menu_type == 1)
				{
					for (st=0;st<max_slots+1;st++)
					{
						if (IsMouseInBox(px,30+12*st, 320-8, 12))
						{
							PlaySound(0);
							sselection = st;
						}
					}
				}
	
	
				if (IsMouseInBox(120,50+12*max_slots,font.getStringWidth("Load Game"),12))
				{
					PlaySound(0);
					if (menu_type == 0)
					{
						//save
						Save(sselection-1);
						stringy = "Game Saved";
						stringy_num = 30;
						ResetData();
					}
					else if (menu_type == 1)
					{
						if (num_areas[sselection-1]>-1)
						{
							stringy = "Game Loaded";
							stringy_num = 30;
						//load
							Load(sselection-1);
						}
					}
				}
	
				if (IsMouseInBox(90,4+2, next.width, next.height))
				{
					PlaySound(0);
					return;
				}
			}
		}

		FlipScreen();
	}
}
